﻿Global Dim m.l(65536)
Global f$

Enumeration
  #disa
  #opt_str
  #opt_file
  #remarks
  #dis
EndEnumeration

Procedure.s b2a(b.l)
  ProcedureReturn RSet(Hex(b&255,#PB_Byte),2,"0")
EndProcedure

Procedure disasm()
ReadFile(0,f$)
adr.l=0

While Not Eof(0)
  m(adr)=ReadAsciiCharacter(0)
  adr+1
  If adr=65536
    MessageRequester("err","File too big",#PB_MessageRequester_Ok)
    CloseFile(0)
    End
  EndIf
Wend

CloseFile(0)

pc=0
remf.l=GetGadgetState(#remarks)
If GetGadgetState(#opt_file)
  CreateFile(1,f$+"-disasm.txt")
EndIf

;http://shop-pdp.net/ashtml/as1802.htm

While pc<adr;$8E
  
  re$="???"
  v$=RSet(Hex(pc),4,"0")
  op.l=m(PC)
  hi.l=(op>>4)&255
  lo.l=op&15
  r$=" R"+Hex(lo)
  n$=" "+Hex(lo)
  pc+1
  
  v$=v$+" "+b2a(op)
  
  re$=""
  Select hi
    Case 0   ;LDN
      If lo
        GetInstr$ = "LDN" + r$
        re$="D=m(Rn)"
      Else
        GetInstr$ = "IDL"
        re$="Stop the execution of instructions, And wait For an interrupt Or DMA To resume"
      EndIf
    Case 1
      GetInstr$ = "INC" + r$
      re$="Rn=Rn+1"
    Case 2
      GetInstr$ = "DEC" + r$
      re$="Rn=Rn-1"
    Case 3
      r$= " "+RSet(Hex( (PC&$FF00)+m(PC)&255),4,"0" )
      ;ValidInstr$ = ValidInstr$ + MKI$((PC And &HFF00&) + RAM(PC))
      If lo<>8;SKP
        v$=v$+" "+b2a(m(PC))
      EndIf
      
      PC = PC + 1
      Select lo
        Case 0:
          GetInstr$ = "BR" + r$
          re$="Branch unconditionally"
        Case 1:
          GetInstr$ = "BQ" + r$
          re$="Branch If Q is on"
        Case 9:
          GetInstr$ = "BNQ" + r$
          re$="Branch if Q is off"
        Case 2:
          GetInstr$ = "BZ" + r$
          re$="Branch if D is zero"
        Case $A:
          GetInstr$ = "BNZ" + r$
          re$="Branch on Not Zero"
        Case 3:
          GetInstr$ = "BDF" + r$
          re$="Branch if DF is 1"
        Case $B:
          GetInstr$ = "BNF" + r$
          re$="Branch if DF is 0"
          ;http://www.cosmacelf.com/publications/books/short-course-in-programming.html#chapter3
          ;https://en.wikipedia.org/wiki/RCA_1802
          ;0020 3F20 LOOP: BN4 *     .. WAIT FOR IT
          ;http://www.kswichit.com/1802/quickstart.pdf
          ; f004 f8 00 DELAY1: LDI 0
          ; f006 a7 PLO R7
          ; f007 27 DELAY2: DEC R7
          ; f008 87 GLO R7
          ; f009 3a 07 BNZ DELAY2
        Case 4:
          GetInstr$ = "B1" + r$
          re$="Branch on External Flag 1"
        Case $C:
          GetInstr$ = "BN1" + r$
          re$="Branch on Not External Flag 1"
        Case 5:
          GetInstr$ = "B2" + r$
          re$="Branch on External Flag 2"
        Case $D:
          GetInstr$ = "BN2" + r$
          re$="Branch on Not External Flag 2"
        Case 6:
          GetInstr$ = "B3" + r$
          re$="Branch on External Flag 3"
        Case $E:
          GetInstr$ = "BN3" + r$
          re$="Branch on Not External Flag 3"
        Case 7:
          GetInstr$ = "B4" + r$
          re$="Branch on External Flag 4"
        Case $F:
          GetInstr$ = "BN4" + r$
          re$="Branch on Not External Flag 1"
        Case 8
          GetInstr$ = "SKP"
          re$="The one-byte instruction following the SKP opcode is skipped"
      EndSelect
    Case 4  ;'LDA
            ; LDA r   Load D And Advance                                 4r
            ; -------------------------------------------------------------
            ; Copy the contents of the memory byte pointed To by the
            ; specified address register r into the Accumulator, And
            ; increment the register.
      GetInstr$ = "LDA" + r$
      re$="D=m(Rn),Rn=Rn+1"
    Case 5
      GetInstr$ = "STR" + r$;STR r   SToRe D into memory                                5r
      re$="m(Rn)=D,SToRe D into memory"
    Case 6
      Select lo
          ; IRX     Increment R(X)                                     60
          ; -------------------------------------------------------------
          ; Increment the register pointed To by X.
        Case 0:
          GetInstr$ = "IRX";RX+1->RX
        Case 1 To 7:
          GetInstr$ = "OUT " +Str(lo)
          re$="out(p),m(Rx),Rx=Rx+1"
        Case 8:
          GetInstr$ = "Invalid code $68"
        Case 9 To $F:
          GetInstr$ = "INP "+Str(lo-8)
          re$="D=in(p),m(Rx)=D,Input to memory and D"
      EndSelect
    Case 7
      Select lo
        Case 0:
          GetInstr$ = "RET"
          re$="(x,p)=m(Rx),Rx=Rx+1,IE=1,Return and enable"
        Case 1:
          GetInstr$ = "DIS"
          re$="(x,p)=m(Rx),Rx=Rx+1,IE=1,Return And DISable interrupts"
        Case 2:
          ;http://www.ittybittycomputers.com/IttyBitty/ShortCor.htm#chapter3
          GetInstr$ = "LDXA"
          re$="D=m(Rx):Rx=Rx+1,Load D via R(X) And Advance"
        Case 3:
          GetInstr$ = "STXD";STXD    STore D via R(X) and Decrement R(X)                73
          re$="m(Rx)=D,Rx=Rx-1"
        Case 4:
          GetInstr$ ="ADC"
          re$="D=D+DF+m(Rx)"
        Case 5:
          GetInstr$ = "SDB"
          re$="Subtract D with Borrow from memory"
        Case 6:
          GetInstr$ = "SHRC"
          re$="DF->D->DF"
        Case 7:
          GetInstr$ = "SMB"
          re$="Subtract Memory with Borrow from D"
        Case 8:
          GetInstr$ = "SAV"
          re$="m(Rx)=T, Save T"
        Case 9:
          GetInstr$ = "MARK"
          re$="Copy X and P into the T register, store T in the memory byte pointed to by R2, then decrement R2; finally copy P into X"
        Case $A:
          GetInstr$ = "REQ"
          re$="Q=0"
        Case $B:
          GetInstr$ = "SEQ"
          re$="Q=1"
        Case $C
          r$ = " #" +b2a(m(PC))
          v$=v$+" "+b2a(m(pc))
          PC = PC + 1
          GetInstr$ = "ADCI" + r$
          re$="D,DF=D+DF+m(Rp),Rp=Rp+1"
        Case $D
          r$ = " #" +b2a(m(PC))
          v$=v$+" "+b2a(m(pc))
          PC = PC + 1
          GetInstr$ = "SDBI" + r$
          re$="Subtract D w.Borrow from memory Immediate byte"
        Case $E:
          GetInstr$ = "SHLC"
          re$="DF<-D<-DF"
        Case $F
          r$ = " #" +b2a(m(PC))
          v$=v$+" "+b2a(m(pc))
          PC = PC + 1
          GetInstr$ = "SMBI" + r$
          re$="Subtract Memory with Borrow from D, Immediate"
      EndSelect
    Case 8
      GetInstr$ = "GLO" + r$
      re$="D=Rn.0,Get Low"
    Case 9
      GetInstr$ = "GHI" + r$
      re$="D=Rn.1,Get High"
    Case $A
      GetInstr$ = "PLO" + r$
      re$="Rn.0=D,Put Low"
    Case $B
      GetInstr$ = "PHI" + r$
      re$="Rn.1=D,Put High"
      ;Long Branch:
      ;LBDF C3 aaaa
      ;LBNF CB aaaa
      ;LBNQ C9 aaaa
      ;LBNZ CA aaaa
      ;LBQ C1 aaaa
      ;LBR C0 aaaa
      ;LBZ C2 aaaa
      ;https://www.emma02.hobby-site.com/1802.html
      ;As I said earlier, the two-byte branch instructions only have one byte of address With which To modify
      ;the PC. The 1802 also has three-byte branch instructions which replace the entire PC With the
      ;contents of the two bytes following the opcode; the first byte is the most significant eight bits, and the
      ;second is the least significant eight bits. Try To convince yourself this is true by clearing memory, then
      ;storing a single SEQ somewhere. Put a hex C0 in location 0000 And the address of the SEQ (in hex) in
      ;bytes 0001 And 0002. When you run the program, Q should come on If And only If the address of the
      ;SEQ exactly matches the address in those two bytes. Notice that it does Not depend on the "I" key.
      
      ;https://en.wikipedia.org/wiki/RCA_1802
      ; 0020 3F20 LOOP: BN4 *     .. WAIT For IT
      ; 0022 6C         INP 4     .. GET IT (NOTE: X=6)
      ; 0023 64         OUT 4     .. ECHO IT
      ; 0024 3724       B4 *      .. WAIT For RELEASE
      ; 0026 26         DEC 6     .. BACK UP R6 To 0060
      ; 0027 26         DEC 6
      ; 0028 46         LDA 6     .. GET 1ST OPERAND To D
      ; 0029 C4   DOIT: NOP       .. DO OPERATION
      ; 002A C4         NOP       .. (SPARE)
      ; 002B 26         DEC 6     .. BACK To 0060
      ; 002C 56         STR 6     .. OUTPUT RESULT
      ; 002D 64         OUT 4     .. (X=6 STILL)
      ; 002E 7A         REQ       .. TURN OFF Q
      ; 002F CA0020     LBNZ LOOP .. THEN If ZERO,
      
    Case $C
      Select lo
        Case 0:
          r$ = b2a(m(pc))
          v$=v$+" "+b2a(m(pc))
          PC = PC + 1
          r$ = r$+b2a(m(PC))
          v$=v$+" "+b2a(m(pc))
          PC = PC + 1
          re$="Long Branch, Rp.1=m(Rp), Rp.0=m(Rp+1)"
          GetInstr$ = "LBR #" + r$

        Case 1:
          r$ = b2a(m(pc))
          v$=v$+" "+b2a(m(pc))
          PC = PC + 1
          r$ = r$+b2a(m(PC))
          v$=v$+" "+b2a(m(pc))
          PC = PC + 1
          re$="Branch if Q=1, if Q=1 then Rp.1=m(Rp), Rp.0=m(Rp+1) else Rp=Rp+2"
          GetInstr$ = "LBQ" + r$
        Case 2:
          r$ = b2a(m(pc))
          v$=v$+" "+b2a(m(pc))
          PC = PC + 1
          r$ = r$+b2a(m(PC))
          v$=v$+" "+b2a(m(pc))
          PC = PC + 1
          re$="Branch if D=0, if D=0 then Rp.1=m(Rp), Rp.0=m(Rp+1) else Rp=Rp+2"
          GetInstr$ = "LBZ" + r$
        Case 3:
          r$ = b2a(m(pc))
          v$=v$+" "+b2a(m(pc))
          PC = PC + 1
          r$ = r$+b2a(m(PC))
          v$=v$+" "+b2a(m(pc))
          PC = PC + 1
          re$="Branch if DF=1, if DF=1 then Rp.1=m(Rp), Rp.0=m(Rp+1) else Rp=Rp+2"
          GetInstr$ = "LBDF" + r$
        Case 9:
          r$ = b2a(m(pc))
          v$=v$+" "+b2a(m(pc))
          PC = PC + 1
          r$ = r$+b2a(m(PC))
          v$=v$+" "+b2a(m(pc))
          PC = PC + 1
          re$="Branch if Q=0, if Q=0 then Rp.1=m(Rp), Rp.0=m(Rp+1) else Rp=Rp+2"
          GetInstr$ = "LBNQ" + r$
        Case $A:
          r$ = b2a(m(pc))
          v$=v$+" "+b2a(m(pc))
          PC = PC + 1
          r$ = r$+b2a(m(PC))
          v$=v$+" "+b2a(m(pc))
          PC = PC + 1
          re$="Branch if D<>0, if D<>0 then Rp.1=m(Rp), Rp.0=m(Rp+1) else Rp=Rp+2"
          GetInstr$ = "LBNZ" + r$
        Case $B:
          r$ = b2a(m(pc))
          v$=v$+" "+b2a(m(pc))
          PC = PC + 1
          r$ = r$+b2a(m(PC))
          v$=v$+" "+b2a(m(pc))
          PC = PC + 1
          re$="Branch if DF=0, if DF00 then Rp.1=m(Rp), Rp.0=m(Rp+1) else Rp=Rp+2"
          GetInstr$ = "LBNF" + r$

        Case 4:
          GetInstr$ = "NOP"
          re$="No Operation"

        Case $C:
          re$="Skip if IE=1,if IE=0, Rp=Rp+2 else Continue"
          GetInstr$ = "LSIE"
        Case 5:
          re$="Skip if Q=0 if Q=0, Rp=Rp+2 else Continue"
          GetInstr$ = "LSNQ"
        Case $D:
          re$="Skip if Q=1 if Q=1, Rp=Rp+2 else Continue"
          GetInstr$ = "LSQ"
        Case 6:
          re$="Skip if D<>0 if D<>0, Rp=Rp+2 else Continue"
          GetInstr$ = "LSNZ"
        Case $E:
          re$="Skip if D=0 if D=0, Rp=Rp+2 else Continue"
          GetInstr$ = "LSZ"
        Case 7:
          re$="Skip if DF=0 if DF=0, Rp=Rp+2 else Continue"
          GetInstr$ = "LSNF"
        Case $F:
          re$="Skip if DF=1 if DF=1, Rp=Rp+2 else Continue"
          GetInstr$ = "LSDF"
        Case 8:
          re$="No long branch, Rp=Rp+2"
          GetInstr$ = "NLBR/LSKP"
      EndSelect

    Case $D
      GetInstr$ = "SEP " + Str(lo)
      re$="Set P="+ Str(lo)
    Case $E
      GetInstr$ = "SEX " + Str(lo)
      re$="Set X="+ Str(lo)
    Case $F
      Select lo
        Case 0:
          GetInstr$ = "LDX"
          re$="D=m(Rx)"
        Case 1:
          GetInstr$ = "OR"
          re$="D=D or m(Rx)"
        Case 2:
          GetInstr$ = "AND"
          re$="D=D and m(Rx)"
        Case 3:
          GetInstr$ = "XOR"
          re$="D=D xor m(Rx)"
        Case 4:
          GetInstr$ = "ADD"
          re$="D=D+m(Rx),DF involves result"
          
        Case 5:
          GetInstr$ = "SD"
          re$="Subtract D from memory"
        Case 6:
          GetInstr$ = "SHR"
          re$="0->D->DF"
        Case 7:
          GetInstr$ = "SM"
          re$="Subtract Memory byte from D"
        Case 8
          r$ = " #" +b2a(m(pc))
          v$=v$+" "+b2a(m(pc))
          re$="Load D Immediate,D="+b2a(m(pc))
          PC = PC + 1
          GetInstr$ = "LDI" + r$
        Case 9
          r$ = " #" +b2a(m(pc))
          v$=v$+" "+b2a(m(pc))
          PC = PC + 1
          GetInstr$ = "ORI" + r$
          re$="D=D or m(Rp),Rp=Rp+1"
        Case $A
          r$ = " #" +b2a(m(pc))
          v$=v$+" "+b2a(m(pc))
          PC = PC + 1
          GetInstr$ = "ANI" + r$
          re$="D=D and m(Rp),Rp=Rp+1"
        Case $B
          r$ = " #" +b2a(m(pc))
          v$=v$+" "+b2a(m(pc))
          PC = PC + 1
          GetInstr$ = "XRI" + r$
          re$="D=D xor m(Rp),Rp=Rp+1"
        Case $C
          r$ = " #" +b2a(m(pc))
          v$=v$+" "+b2a(m(pc))
          PC = PC + 1
          GetInstr$ = "ADI" + r$
          re$="D=D+N,Add Immediate"
        Case $D
          r$ = " #" +b2a(m(pc))
          v$=v$+" "+b2a(m(pc))
          PC = PC + 1
          GetInstr$ = "SDI" + r$
          re$="Subtract D from Immediate byte"
        Case $E:
          GetInstr$ = "SHL"
          re$="DF<-D<-0"
        Case $F
          r$ = " #" +b2a(m(pc))
          v$=v$+" "+b2a(m(pc))
          PC = PC + 1
          GetInstr$ = "SMI" + r$
          re$="Subtract Memory from D, Immediate,D=D-m(Rx)+DF, incomplete description"
      EndSelect
  EndSelect
  
  sep$=" "
  If Len(v$)=10:sep$=Chr(9):EndIf
  If Len(v$)=7:sep$=Chr(9)+Chr(9):EndIf
  
  If remf
    v$=v$+sep$+GetInstr$+Chr(9)+Chr(9)+".."+re$
  Else
    v$=v$+sep$+GetInstr$;+Chr(9)+Chr(9)+".."+re$
  EndIf
  If GetGadgetState(#opt_file)
    WriteStringN(1,v$);+sep$+GetInstr$+Chr(9)+Chr(9)+".."+re$)
  Else
;    SetGadgetText(#dis,GetGadgetText(#dis)+v$+sep$+GetInstr$+Chr(9)+Chr(9)+".."+re$+#CRLF$)
    SetGadgetText(#dis,GetGadgetText(#dis)+v$+#CRLF$)
;    ev=WindowEvent()
  EndIf
StatusBarText(0, 0, RSet(Hex(pc),4,"0"),#PB_StatusBar_Raised )
Wend
If GetGadgetState(#opt_file)
  CloseFile(1)
EndIf

EndProcedure

;;;;;;;;;;;;G U I;;;;;;;;;;;;

If OpenWindow(0, 0, 0, 640, 480, "1802 disassembler 0.9", #PB_Window_SystemMenu | #PB_Window_ScreenCentered|#PB_Window_MinimizeGadget)
  StringGadget(#disa, 0, 10, 190, 20, "0",#ES_RIGHT)
  OptionGadget(#opt_str, 200, 10, 100, 20, "to field")
  OptionGadget(#opt_file, 300, 10, 100, 20, "to file")
  CheckBoxGadget(#remarks, 400, 10, 100, 20, "add remarks")
  StringGadget(#dis, 0, 35, 630, 420, "",#ES_MULTILINE|#ES_AUTOVSCROLL|#WS_VSCROLL|#WS_HSCROLL|#ESB_DISABLE_LEFT|#ESB_DISABLE_RIGHT)
  SetGadgetState(#opt_str,1)
  SetGadgetState(#remarks,1)
  
  GadgetToolTip(#disa,"An address for disassembly")
  GadgetToolTip(#opt_str,"output to text filed")
  GadgetToolTip(#opt_file,"save to text file")
  GadgetToolTip(#remarks," add remarks for opcodes")
  GadgetToolTip(#dis,"Drag file here")
  
  EnableWindowDrop(0,#PB_Drop_Files,#PB_Drag_Copy)
  CreateStatusBar(0, WindowID(0))
  AddStatusBarField(90)

  isq.l=0

  Repeat
    event=WaitWindowEvent()
    If GetAsyncKeyState_(#VK_ESCAPE)=-32767
      isq=1
    EndIf
    Select event
      Case #PB_Event_WindowDrop
        F$ = EventDropFiles()
        disasm()
      Case #PB_Event_CloseWindow
        isq=1
      EndSelect
  Until isq
  EndIf

; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 400
; FirstLine = 377
; Folding = -
; EnableUnicode
; EnableXP
; UseIcon = dasm1802.ico
; Executable = dasm1802.exe